## pcre3 4.5+7.4

=== CMakeLists.txt ===
# CMakeLists.txt
#
#
# This file allows building PCRE with the CMake configuration and build
# tool. Download CMake in source or binary form from http://www.cmake.org/
#
# Original listfile by Christian Ehrlicher <Ch.Ehrlicher@gmx.de>
# Refined and expanded by Daniel Richard G. <skunk@iSKUNK.ORG>
# 2007-09-14 mod by Sheri so 7.4 supported configuration options can be entered
# 2007-09-19 Adjusted by PH to retain previous default settings
#

PROJECT(PCRE C CXX)

CMAKE_MINIMUM_REQUIRED(VERSION 2.4.6)

# Configuration checks

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckTypeSize)

CHECK_INCLUDE_FILE(dirent.h	HAVE_DIRENT_H)
CHECK_INCLUDE_FILE(unistd.h	HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(sys/stat.h	HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE(sys/types.h	HAVE_SYS_TYPES_H)

CHECK_INCLUDE_FILE_CXX(type_traits.h		HAVE_TYPE_TRAITS_H)
CHECK_INCLUDE_FILE_CXX(bits/type_traits.h	HAVE_BITS_TYPE_TRAITS_H)

CHECK_FUNCTION_EXISTS(bcopy	HAVE_BCOPY)
CHECK_FUNCTION_EXISTS(memmove	HAVE_MEMMOVE)
CHECK_FUNCTION_EXISTS(strerror	HAVE_STRERROR)

CHECK_TYPE_SIZE("long long"		LONG_LONG)
CHECK_TYPE_SIZE("unsigned long long"	UNSIGNED_LONG_LONG)

# User-configurable options
#
# (Note: CMakeSetup displays these in alphabetical order, regardless of
# the order we use here)

SET(BUILD_SHARED_LIBS OFF CACHE BOOL
    "Build shared libraries instead of static ones.")

OPTION(PCRE_BUILD_PCRECPP "Build the PCRE C++ library (pcrecpp)." ON)

SET(PCRE_EBCDIC OFF CACHE BOOL
    "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems)")

SET(PCRE_LINK_SIZE "2" CACHE STRING
    "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")

SET(PCRE_MATCH_LIMIT "10000000" CACHE STRING
    "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")

SET(PCRE_MATCH_LIMIT_RECURSION "MATCH_LIMIT" CACHE STRING
    "Default limit on internal recursion. See MATCH_LIMIT_RECURSION in config.h.in for details.")

SET(PCRE_NEWLINE "LF" CACHE STRING
    "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF).")

SET(PCRE_NO_RECURSE OFF CACHE BOOL
    "If ON, then don't use stack recursion when matching. See NO_RECURSE in config.h.in for details.")

SET(PCRE_POSIX_MALLOC_THRESHOLD "10" CACHE STRING
    "Threshold for malloc() usage. See POSIX_MALLOC_THRESHOLD in config.h.in for details.")

SET(PCRE_SUPPORT_UNICODE_PROPERTIES OFF CACHE BOOL
    "Enable support for Unicode properties. (If set, UTF-8 support will be enabled as well)")

SET(PCRE_SUPPORT_UTF8 OFF CACHE BOOL
    "Enable support for the Unicode UTF-8 encoding.")

SET(PCRE_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL
    "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")

# Prepare build configuration

SET(pcre_have_type_traits 0)
SET(pcre_have_bits_type_traits 0)

IF(HAVE_TYPE_TRAITS_H)
	SET(pcre_have_type_traits 1)
ENDIF(HAVE_TYPE_TRAITS_H)

IF(HAVE_BITS_TYPE_TRAITS_H)
	SET(pcre_have_bits_type_traits 1)
ENDIF(HAVE_BITS_TYPE_TRAITS_H)

SET(pcre_have_long_long 0)
SET(pcre_have_ulong_long 0)

IF(HAVE_LONG_LONG)
	SET(pcre_have_long_long 1)
ENDIF(HAVE_LONG_LONG)

IF(HAVE_UNSIGNED_LONG_LONG)
	SET(pcre_have_ulong_long 1)
ENDIF(HAVE_UNSIGNED_LONG_LONG)

IF(NOT BUILD_SHARED_LIBS)
	SET(PCRE_STATIC 1)
ENDIF(NOT BUILD_SHARED_LIBS)

IF(PCRE_SUPPORT_BSR_ANYCRLF)
	SET(BSR_ANYCRLF 1)
ENDIF(PCRE_SUPPORT_BSR_ANYCRLF)

IF(PCRE_SUPPORT_UTF8 OR PCRE_SUPPORT_UNICODE_PROPERTIES)
	SET(SUPPORT_UTF8 1)
ENDIF(PCRE_SUPPORT_UTF8 OR PCRE_SUPPORT_UNICODE_PROPERTIES)

IF(PCRE_SUPPORT_UNICODE_PROPERTIES)
	SET(SUPPORT_UCP 1)
ENDIF(PCRE_SUPPORT_UNICODE_PROPERTIES)

SET(NEWLINE "")

IF(PCRE_NEWLINE STREQUAL "LF")
	SET(NEWLINE "10")
ENDIF(PCRE_NEWLINE STREQUAL "LF")
IF(PCRE_NEWLINE STREQUAL "CR")
	SET(NEWLINE "13")
ENDIF(PCRE_NEWLINE STREQUAL "CR")
IF(PCRE_NEWLINE STREQUAL "CRLF")
	SET(NEWLINE "3338")
ENDIF(PCRE_NEWLINE STREQUAL "CRLF")
IF(PCRE_NEWLINE STREQUAL "ANY")
	SET(NEWLINE "-1")
ENDIF(PCRE_NEWLINE STREQUAL "ANY")
IF(PCRE_NEWLINE STREQUAL "ANYCRLF")
	SET(NEWLINE "-2")
ENDIF(PCRE_NEWLINE STREQUAL "ANYCRLF")

IF(NEWLINE STREQUAL "")
	MESSAGE(FATAL_ERROR "The PCRE_NEWLINE variable must be set to one of the following values: \"LF\", \"CR\", \"CRLF\", \"ANY\", \"ANYCRLF\".")
ENDIF(NEWLINE STREQUAL "")

IF(PCRE_EBCDIC)
	SET(EBCDIC 1)
ENDIF(PCRE_EBCDIC)

IF(PCRE_NO_RECURSE)
	SET(NO_RECURSE 1)
ENDIF(PCRE_NO_RECURSE)

# Output files

CONFIGURE_FILE(config-cmake.h.in
               ${CMAKE_BINARY_DIR}/config.h
               @ONLY)

CONFIGURE_FILE(pcre.h.generic
               ${CMAKE_BINARY_DIR}/pcre.h
               COPYONLY)

# What about pcre-config and libpcre.pc?

IF(PCRE_BUILD_PCRECPP)
	CONFIGURE_FILE(pcre_stringpiece.h.in
		       ${CMAKE_BINARY_DIR}/pcre_stringpiece.h
		       @ONLY)

	CONFIGURE_FILE(pcrecpparg.h.in
		       ${CMAKE_BINARY_DIR}/pcrecpparg.h
		       @ONLY)
ENDIF(PCRE_BUILD_PCRECPP)

# Character table generation

ADD_EXECUTABLE(dftables dftables.c)

GET_TARGET_PROPERTY(DFTABLES_EXE dftables LOCATION)

ADD_CUSTOM_COMMAND(
	COMMENT "Generating character tables (pcre_chartables.c) for current locale"
	DEPENDS dftables
	COMMAND ${DFTABLES_EXE}
	ARGS	${CMAKE_BINARY_DIR}/pcre_chartables.c
	OUTPUT	${CMAKE_BINARY_DIR}/pcre_chartables.c
)

# Source code

SET(PCRE_HEADERS ${CMAKE_BINARY_DIR}/pcre.h)

SET(PCRE_SOURCES
	${CMAKE_BINARY_DIR}/pcre_chartables.c
	pcre_compile.c
	pcre_config.c
	pcre_dfa_exec.c
	pcre_exec.c
	pcre_fullinfo.c
	pcre_get.c
	pcre_globals.c
	pcre_info.c
	pcre_newline.c
	pcre_maketables.c
	pcre_ord2utf8.c
	pcre_refcount.c
	pcre_study.c
	pcre_tables.c
	pcre_try_flipped.c
	pcre_ucp_searchfuncs.c
	pcre_valid_utf8.c
	pcre_version.c
	pcre_xclass.c
)

SET(PCREPOSIX_HEADERS pcreposix.h)

SET(PCREPOSIX_SOURCES pcreposix.c)

SET(PCRECPP_HEADERS
	pcrecpp.h
	pcre_scanner.h
	${CMAKE_BINARY_DIR}/pcrecpparg.h
	${CMAKE_BINARY_DIR}/pcre_stringpiece.h
)

SET(PCRECPP_SOURCES
	pcrecpp.cc
	pcre_scanner.cc
	pcre_stringpiece.cc
)

# Build setup

ADD_DEFINITIONS(-DHAVE_CONFIG_H)

IF(WIN32)
	ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
ENDIF(WIN32)

SET(CMAKE_INCLUDE_CURRENT_DIR 1)

#SET(CMAKE_DEBUG_POSTFIX "d")

# Libraries

ADD_LIBRARY(pcre ${PCRE_HEADERS} ${PCRE_SOURCES})

ADD_LIBRARY(pcreposix ${PCREPOSIX_HEADERS} ${PCREPOSIX_SOURCES})
TARGET_LINK_LIBRARIES(pcreposix pcre)

SET_TARGET_PROPERTIES(pcre pcreposix
                        PROPERTIES PREFIX ""
)

IF(PCRE_BUILD_PCRECPP)
	ADD_LIBRARY(pcrecpp ${PCRECPP_HEADERS} ${PCRECPP_SOURCES})
	TARGET_LINK_LIBRARIES(pcrecpp pcre)
	IF(MINGW)
		SET_TARGET_PROPERTIES(pcrecpp PROPERTIES PREFIX "mingw-")
	ENDIF(MINGW)
ENDIF(PCRE_BUILD_PCRECPP)

# Executables

ADD_EXECUTABLE(pcretest pcretest.c)
TARGET_LINK_LIBRARIES(pcretest pcreposix)

ADD_EXECUTABLE(pcregrep pcregrep.c)
TARGET_LINK_LIBRARIES(pcregrep pcreposix)

IF(PCRE_BUILD_PCRECPP)
	ADD_EXECUTABLE(pcrecpp_unittest pcrecpp_unittest.cc)
	TARGET_LINK_LIBRARIES(pcrecpp_unittest pcrecpp)

	ADD_EXECUTABLE(pcre_scanner_unittest pcre_scanner_unittest.cc)
	TARGET_LINK_LIBRARIES(pcre_scanner_unittest pcrecpp)

	ADD_EXECUTABLE(pcre_stringpiece_unittest pcre_stringpiece_unittest.cc)
	TARGET_LINK_LIBRARIES(pcre_stringpiece_unittest pcrecpp)
ENDIF(PCRE_BUILD_PCRECPP)

# Testing

ENABLE_TESTING()

GET_TARGET_PROPERTY(PCREGREP_EXE pcregrep DEBUG_LOCATION)
GET_TARGET_PROPERTY(PCRETEST_EXE pcretest DEBUG_LOCATION)

# Write out a CTest configuration file that sets some needed environment
# variables for the test scripts.
#
FILE(WRITE ${CMAKE_BINARY_DIR}/CTestCustom.ctest
"# This is a generated file.
SET(ENV{srcdir} ${CMAKE_SOURCE_DIR})
SET(ENV{pcregrep} ${PCREGREP_EXE})
SET(ENV{pcretest} ${PCRETEST_EXE})
")

IF(UNIX)
	ADD_TEST(pcre_test	${CMAKE_SOURCE_DIR}/RunTest)
	ADD_TEST(pcre_grep_test ${CMAKE_SOURCE_DIR}/RunGrepTest)
ENDIF(UNIX)
IF(WIN32)
	ADD_TEST(pcre_test cmd /C ${CMAKE_SOURCE_DIR}/RunTest.bat)
ENDIF(WIN32)

GET_TARGET_PROPERTY(PCRECPP_UNITTEST_EXE
                    pcrecpp_unittest
                    DEBUG_LOCATION)

GET_TARGET_PROPERTY(PCRE_SCANNER_UNITTEST_EXE
                    pcre_scanner_unittest
                    DEBUG_LOCATION)

GET_TARGET_PROPERTY(PCRE_STRINGPIECE_UNITTEST_EXE
                    pcre_stringpiece_unittest
                    DEBUG_LOCATION)

ADD_TEST(pcrecpp_test          ${PCRECPP_UNITTEST_EXE})
ADD_TEST(pcre_scanner_test     ${PCRE_SCANNER_UNITTEST_EXE})
ADD_TEST(pcre_stringpiece_test ${PCRE_STRINGPIECE_UNITTEST_EXE})

# Installation

SET(CMAKE_INSTALL_ALWAYS 1)

INSTALL(TARGETS pcre pcreposix pcregrep pcretest
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

INSTALL(FILES ${PCRE_HEADERS} ${PCREPOSIX_HEADERS} DESTINATION include)

FILE(GLOB html ${CMAKE_SOURCE_DIR}/doc/html/*.html)
FILE(GLOB man1 ${CMAKE_SOURCE_DIR}/doc/*.1)
FILE(GLOB man3 ${CMAKE_SOURCE_DIR}/doc/*.3)

IF(PCRE_BUILD_PCRECPP)
	INSTALL(TARGETS pcrecpp
		RUNTIME DESTINATION bin
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib)
	INSTALL(FILES ${PCRECPP_HEADERS} DESTINATION include)
ELSE(PCRE_BUILD_PCRECPP)
	# Remove pcrecpp.3
	FOREACH(man ${man3})
		GET_FILENAME_COMPONENT(man_tmp ${man} NAME)
		IF(NOT man_tmp STREQUAL "pcrecpp.3")
			SET(man3_new ${man3} ${man})
		ENDIF(NOT man_tmp STREQUAL "pcrecpp.3")
	ENDFOREACH(man ${man3})
	SET(man3 ${man3_new})
ENDIF(PCRE_BUILD_PCRECPP)

INSTALL(FILES ${man1} DESTINATION man/man1)
INSTALL(FILES ${man3} DESTINATION man/man3)
INSTALL(FILES ${html} DESTINATION share/doc/pcre/html)

# end CMakeLists.txt

## pcre3 8.30

=== debian/changelog ===
pcre3 (1:8.30-5) unstable; urgency=low

  * There is no use in including debug information for the libraries from
    the udeb in the debug package; more importantly, because the
    installation system isn't multiarch, if they are included they result
    in arch specific files in arch independent paths (debug package is 
    Multi-arch:same). Removed. (Closes: #670018)

 -- Mark Baker <mark@mnb.org.uk>  Tue, 01 May 2012 22:38:42 +0100

pcre3 (1:8.30-4) unstable; urgency=low

  * Reluctantly using an epoch, as it seems the funny version number with
    extra dots causes problems
  * Bumped standard version to 3.9.3. No changes needed
  * Converted to use new source format / quilt
  * Put back obsolete pcre_info() API that upstream have dropped (Closes:
    #665300, #665356)
  * Don't include pcregrep binary in debug package

  Thanks to Elimar Riesebieter for the conversion to the new source format.

 -- Mark Baker <mark@mnb.org.uk>  Fri, 23 Mar 2012 22:34:54 +0000

pcre3 (8.30..-3) unstable; urgency=low

  * configure: fixed libpcreposix version (this is not the same bug as the
    previous one, though it's in the same few lines)

 -- Mark Baker <mark@mnb.org.uk>  Thu, 22 Mar 2012 19:45:03 +0000

pcre3 (8.30..-2) unstable; urgency=low

  * configure: Correct library version so soname is libpcre.so.3 instead
    of .2 (Closes: #664983)
  * Horrible version number is because of NMU of "8.30.really8.12-1.1";
    this will sort between that and 8.31-1
  
 -- Mark Baker <mark@mnb.org.uk>  Thu, 22 Mar 2012 17:52:35 +0000

pcre3 (8.30-1) unstable; urgency=low

  * New upstream release (Closes:#664166)

 -- Mark Baker <mark@mnb.org.uk>  Wed, 21 Mar 2012 21:03:39 +0000

pcre3 (8.12-4) unstable; urgency=low

  * Multi-arch support. Thanks Steve Langasek for patch (Closes: 634250)

 -- Mark Baker <mark@mnb.org.uk>  Mon, 18 Jul 2011 21:59:44 +0100

pcre3 (8.12-3) unstable; urgency=low

  * debian/rules: Increased shlib version to 8.10 (Closes: #612942,
    #613227, #613469, #614012, #615019)

 -- Mark Baker <mark@mnb.org.uk>  Sun, 20 Feb 2011 12:46:44 +0000

pcre3 (8.12-2) unstable; urgency=low

  * Include changes from Stéphane's NMU (including fix for bug 581202)
    that were accidentally omitted in previous release.
  * debian/control: -dbg package should be section debug, priority extra

 -- Mark Baker <mark@mnb.org.uk>  Tue, 08 Feb 2011 20:38:49 +0000

pcre3 (8.12-1) unstable; urgency=low

  * New upstream release (Closes: #554242)

 -- Mark Baker <mark@mnb.org.uk>  Mon, 07 Feb 2011 23:53:42 +0000

pcre3 (8.02-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add explicit Breaks to applications using libpcre-ocaml, to allow
    proper upgrades from lenny (Closes: #581202)
  * Add debian/watch
  * Add debian/source/format
  * Remove duplicate fields spotted by Lintian
  * Promote XC-Package-Type field to Package-Type

 -- Stéphane Glondu <glondu@debian.org>  Sat, 31 Jul 2010 16:05:27 -0400

pcre3 (8.02-1) unstable; urgency=low

  * New upstream release

 -- Mark Baker <mark@mnb.org.uk>  Fri, 07 May 2010 21:18:05 +0100

pcre3 (7.8-3) unstable; urgency=low

  * debian/rules: Install main library in /lib (Closes: 350468, #549608)
  * debian/pcre-config.1: Minor formatting changes (thanks Alexander
    Peslyak) (Closes: 338658) 
  * Makefile.am,Makefile.in: Added libpcre.la to LDADD for various things;
    apparently this will make it cross-build successfully (Closes: 492565)
  * debian/control: Added ${misc:Depends} to dependencies for all the
    binary packages
  * debian/rules: Don't ignore errors from make distclean

 -- Mark Baker <mark@mnb.org.uk>  Wed, 07 Oct 2009 00:05:25 +0100

pcre3 (7.8-2) unstable; urgency=low

  * debian/rules: Bumped shlib version to 7.7 because of new feature in
    that version (Closes: #500987)

 -- Mark Baker <mark@mnb.org.uk>  Sun, 05 Oct 2008 17:06:46 +0100

pcre3 (7.8-1) unstable; urgency=low

  * New upstream release

 -- Mark Baker <mark@mnb.org.uk>  Sun, 21 Sep 2008 21:23:00 +0100

pcre3 (7.6-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Fix heap overflow in the pcre compiler triggered by
    patterns which contain options and multiple branches
    (CVE-2008-2371; Closes: #488919).
  * debian/rules (patch by Bryan Donlan): Update shlibdeps invocation for
    libpcrecpp0 due to new symbols (Closes: #476925).
  * debian/copyright: replace license information with the current license
    information shipped with upstream sources (Closes: #489318).

 -- Nico Golde <nion@debian.org>  Mon, 14 Jul 2008 19:13:11 +0200

pcre3 (7.6-2) unstable; urgency=low

  * pcrecpp.cc: Applied patch from PCRE bugzilla (bug 664) to fix ABI
    breakage (Closes: #463170, #463266, #463413, #464974)
  
 -- Mark Baker <mark@mnb.org.uk>  Wed, 13 Feb 2008 22:19:35 +0000

pcre3 (7.6-1) unstable; urgency=low

  * New upstream release
  * Ship pcredemo.c in examples directory (Closes: #377587)

 -- Mark Baker <mark@mnb.org.uk>  Mon, 28 Jan 2008 23:01:05 +0000

pcre3 (7.4-1) unstable; urgency=low

  * Build a -dbg package with debug symbols
  
  Thanks to Sebastian Dröge <slomo@debian.org>,for all of the following:

  * New upstream release (Closes: #453372).
  * debian/control,
    debian/rules:
    + Provide udeb (Closes: #443114). Build depend on debhelper (>= 5.0.22)
      for this.
  * debian/rules:
    + Bump shlibs to >= 7.4 (Closes: #449289).
  * debian/compat:
    + Update debhelper compat level to 5.
  * debian/control:
    + Update Standards-Version to 3.7.3, no additional changes needed.
    + Use ${binary:Version} instead of ${Source-Version} to make package
      binNMU safe.
  * debian/*.files,
    debian/*.install,
    debian/rules:
    + Convert from dh_movefiles to dh_install.
  * debian/*.dirs:
    + Removed, not necessary.

 -- Mark Baker <mark@mnb.org.uk>  Mon,  7 Jan 2008 21:03:34 +0000

pcre3 (7.3-2) unstable; urgency=low

  * Overloaded RE::Init(), for compatibility with PCRE 6.x API (Closes


=== debian/control ===
Source: pcre3
Section: libs
Priority: optional
Maintainer:  Mark Baker <mark@mnb.org.uk>
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 5.0.22), dpkg-dev (>= 1.16.0)

Package: libpcre3
Section: libs
Architecture: any
Priority: important
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libpcre3-dev (<= 4.3-3)
Breaks:
 libpcre-ocaml (<< 6.0.1~),
 approx (<< 4.4-1~),
 cmigrep (<< 1.5-7~),
 ocsigen (<< 1.3.3-1~),
 cduce (<< 0.5.3-2~),
 galax (<< 1.1-7~),
 liquidsoap (<< 0.9.2-3~)
Multi-Arch: same
Pre-Depends: multiarch-support
Description: Perl 5 Compatible Regular Expression Library - runtime files
 This is a library of functions to support regular expressions whose syntax 
 and semantics are as close as possible to those of the Perl 5 language.
 .
 This package contains the runtime libraries.

Package: libpcre3-udeb
Section: debian-installer
Package-Type: udeb
Architecture: any
Priority: important
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libpcre3-dev (<= 4.3-3)
Description: Perl 5 Compatible Regular Expression Library - runtime files (udeb)
 This is a library of functions to support regular expressions whose syntax 
 and semantics are as close as possible to those of the Perl 5 language.
 .
 This package contains the runtime libraries for the Debian Installer (udeb).

Package: libpcrecpp0
Section: libs
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libpcre3 (<< 6.4-1.1)
Replaces: libpcre3 (<< 6.4-1.1)
Multi-Arch: same
Pre-Depends: multiarch-support
Description: Perl 5 Compatible Regular Expression Library - C++ runtime files
 This is a C++ library of functions to support regular expressions whose syntax 
 and semantics are as close as possible to those of the Perl 5 language.
 .
 This package contains the C++ runtime library.

Package: libpcre3-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, libpcre3 (= ${binary:Version}), libpcrecpp0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libpcre1-dev, libpcre2-dev
Description: Perl 5 Compatible Regular Expression Library - development files
 This is a library of functions to support regular expressions whose syntax 
 and semantics are as close as possible to those of the Perl 5 language.
 .
 This package contains the development files, including headers, static 
 libraries, and documentation.

Package: libpcre3-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libpcre3 (= ${binary:Version}), libpcrecpp0 (= ${binary:Version}),  ${misc:Depends}
Multi-Arch: same
Description: Perl 5 Compatible Regular Expression Library - debug symbols
 This is a library of functions to support regular expressions whose syntax 
 and semantics are as close as possible to those of the Perl 5 language.
 .
 This package contains the debug symbols,

Package: pcregrep
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: pgrep (<<4.5)
Description: grep utility that uses perl 5 compatible regexes.
 Perl-style regexps have many useful features that the standard POSIX ones
 don't; this is basically the same as grep but with the different
 regexp syntax.
 .
 The other reason for the existence of pcregrep is that its source code is an
 example of programming with libpcre.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = -Wall -g
INSTALL = install
INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
INSTALL_SCRIPT  = $(INSTALL) -p    -o root -g root  -m  755
INSTALL_DIR     = $(INSTALL) -p -d -o root -g root  -m  755

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif


config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	CC_FOR_BUILD=cc CFLAGS="$(CFLAGS)" ./configure \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--enable-utf8 --enable-unicode-properties

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(MAKE) check
endif

	touch build-stamp

clean: config.status
	dh_testdir
	dh_testroot
	rm -f build-stamp
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
###	-test -r /usr/share/misc/config.sub && \
###	  cp -f /usr/share/misc/config.sub config.sub
###	-test -r /usr/share/misc/config.guess && \
###	  cp -f /usr/share/misc/config.guess config.guess
	rm -f dftables testsavedregex
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_install -a
	# This man page is in the main package, don't want it in -dev
	rm debian/libpcre3-dev/usr/share/man/man3/pcrepattern.3
	# Move actual library to /lib
	mkdir -p debian/libpcre3/lib/$(DEB_HOST_MULTIARCH)
	mv debian/libpcre3/usr/lib/$(DEB_HOST_MULTIARCH)/libpcre.so.* debian/libpcre3/lib/$(DEB_HOST_MULTIARCH)
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/libpcre.so.3 debian/libpcre3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libpcre.so

	dh_link -a

#	dh_installdebconf -a
	dh_installdocs -a
	dh_installexamples -a
#	dh_installmenu -a
#	dh_installlogrotate -a
#	dh_installemacsen -a
#	dh_installpam -a
#	dh_installmime -a
#	dh_installinit -a
#	dh_installcron -a
	dh_installman -a
	dh_installinfo -a
#	dh_undocumented -a
	dh_installchangelogs -a ChangeLog
	dh_strip -a --dbg-package=libpcre3-dbg
	# Don't include pcregrep or libraries from udeb in debug package
	rm -r debian/libpcre3-dbg/usr/lib/debug/usr/bin 
	rm debian/libpcre3-dbg/usr/lib/debug/usr/lib/libpcre*
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb" -V 'libpcre3 (>= 8.10)'
	dh_makeshlibs -plibpcrecpp0 -V 'libpcrecpp0 (>= 7.7)'
	dh_installdeb -a
#	dh_perl -a
	dh_shlibdeps -a -ldebian/libpcre3/usr/lib/$(DEB_HOST_MULTIARCH)
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep:

binary: binary-arch binary-indep
.PHONY: build clean binary-arch binary install

## pcre3 8.31

=== CMakeLists.txt ===
# CMakeLists.txt
#
#
# This file allows building PCRE with the CMake configuration and build
# tool. Download CMake in source or binary form from http://www.cmake.org/
#
# Original listfile by Christian Ehrlicher <Ch.Ehrlicher@gmx.de>
# Refined and expanded by Daniel Richard G. <skunk@iSKUNK.ORG>
# 2007-09-14 mod by Sheri so 7.4 supported configuration options can be entered
# 2007-09-19 Adjusted by PH to retain previous default settings
# 2007-12-26 (a) On UNIX, use names libpcre instead of just pcre
#            (b) Ensure pcretest and pcregrep link with the local library,
#                not a previously-installed one.
#            (c) Add PCRE_SUPPORT_LIBREADLINE, PCRE_SUPPORT_LIBZ, and
#                PCRE_SUPPORT_LIBBZ2.
# 2008-01-20 Brought up to date to include several new features by Christian
#            Ehrlicher.
# 2008-01-22 Sheri added options for backward compatibility of library names
#            when building with minGW:
#            if "ON", NON_STANDARD_LIB_PREFIX causes shared libraries to
#            be built without "lib" as prefix. (The libraries will be named
#            pcre.dll, pcreposix.dll and pcrecpp.dll).
#            if "ON", NON_STANDARD_LIB_SUFFIX causes shared libraries to
#            be built with suffix of "-0.dll". (The libraries will be named
#            libpcre-0.dll, libpcreposix-0.dll and libpcrecpp-0.dll - same names
#            built by default with Configure and Make.
# 2008-01-23 PH removed the automatic build of pcredemo.
# 2008-04-22 PH modified READLINE support so it finds NCURSES when needed.
# 2008-07-03 PH updated for revised UCP property support (change of files)
# 2009-03-23 PH applied Steven Van Ingelgem's patch to change the name
#            CMAKE_BINARY_DIR to PROJECT_BINARY_DIR so that it works when PCRE
#            is included within another project.
# 2009-03-23 PH applied a modified version of Steven Van Ingelgem's patches to
#            add options to stop the building of pcregrep and the tests, and
#            to disable the final configuration report.
# 2009-04-11 PH applied Christian Ehrlicher's patch to show compiler flags that
#            are set by specifying a release type.
# 2010-01-02 PH added test for stdint.h
# 2010-03-02 PH added test for inttypes.h
# 2011-08-01 PH added PCREGREP_BUFSIZE
# 2011-08-22 PH added PCRE_SUPPORT_JIT
# 2011-09-06 PH modified WIN32 ADD_TEST line as suggested by Sergey Cherepanov
# 2011-09-06 PH added PCRE_SUPPORT_PCREGREP_JIT
# 2011-10-04 Sheri added support for including coff data in windows shared libraries
#            compiled with MINGW if pcre.rc and/or pcreposix.rc are placed in
#            the source dir by the user prior to building
# 2011-10-04 Sheri changed various add_test's to use exes' location built instead
#            of DEBUG location only (likely only matters in MSVC)
# 2011-10-04 Sheri added scripts to provide needed variables to RunTest and
#            RunGrepTest (used for UNIX and Msys)
# 2011-10-04 Sheri added scripts to provide needed variables and to execute
#            RunTest.bat in Win32 (for effortless testing with "make test")
# 2011-10-04 Sheri Increased minimum required cmake version
# 2012-01-06 PH removed pcre_info.c and added pcre_string_utils.c
# 2012-01-10 Zoltan Herczeg added libpcre16 support
# 2012-01-13 Stephen Kelly added out of source build support
# 2012-01-17 PH applied Stephen Kelly's patch to parse the version data out
#            of the configure.ac file
# 2012-02-26 PH added support for libedit

PROJECT(PCRE C CXX)

# Increased minimum to 2.8.0 to support newer add_test features

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0)

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake) # for FindReadline.cmake

# external packages
FIND_PACKAGE( BZip2 )
FIND_PACKAGE( ZLIB )
FIND_PACKAGE( Readline )
FIND_PACKAGE( Editline )

# Configuration checks

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckTypeSize)

CHECK_INCLUDE_FILE(dirent.h     HAVE_DIRENT_H)
CHECK_INCLUDE_FILE(stdint.h     HAVE_STDINT_H)
CHECK_INCLUDE_FILE(inttypes.h   HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE(sys/stat.h   HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE(sys/types.h  HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(unistd.h     HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(windows.h    HAVE_WINDOWS_H)

CHECK_INCLUDE_FILE_CXX(type_traits.h            HAVE_TYPE_TRAITS_H)
CHECK_INCLUDE_FILE_CXX(bits/type_traits.h       HAVE_BITS_TYPE_TRAITS_H)

CHECK_FUNCTION_EXISTS(bcopy     HAVE_BCOPY)
CHECK_FUNCTION_EXISTS(memmove   HAVE_MEMMOVE)
CHECK_FUNCTION_EXISTS(strerror  HAVE_STRERROR)
CHECK_FUNCTION_EXISTS(strtoll   HAVE_STRTOLL)
CHECK_FUNCTION_EXISTS(strtoq    HAVE_STRTOQ)
CHECK_FUNCTION_EXISTS(_strtoi64 HAVE__STRTOI64)

CHECK_TYPE_SIZE("long long"             LONG_LONG)
CHECK_TYPE_SIZE("unsigned long long"    UNSIGNED_LONG_LONG)

# User-configurable options
#
# (Note: CMakeSetup displays these in alphabetical order, regardless of
# the order we use here)

SET(BUILD_SHARED_LIBS OFF CACHE BOOL
    "Build shared libraries instead of static ones.")

OPTION(PCRE_BUILD_PCRE8 "Build 8 bit PCRE library" ON)

OPTION(PCRE_BUILD_PCRE16 "Build 16 bit PCRE library" OFF)

OPTION(PCRE_BUILD_PCRECPP "Build the PCRE C++ library (pcrecpp)." ON)

SET(PCRE_EBCDIC OFF CACHE BOOL
    "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems)")

SET(PCRE_LINK_SIZE "2" CACHE STRING
    "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")

SET(PCRE_MATCH_LIMIT "10000000" CACHE STRING
    "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")

SET(PCRE_MATCH_LIMIT_RECURSION "MATCH_LIMIT" CACHE STRING
    "Default limit on internal recursion. See MATCH_LIMIT_RECURSION in config.h.in for details.")

SET(PCREGREP_BUFSIZE "20480" CACHE STRING
    "Buffer size parameter for pcregrep. See PCREGREP_BUFSIZE in config.h.in for details.")

SET(PCRE_NEWLINE "LF" CACHE STRING
    "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF).")

SET(PCRE_NO_RECURSE OFF CACHE BOOL
    "If ON, then don't use stack recursion when matching. See NO_RECURSE in config.h.in for details.")

SET(PCRE_POSIX_MALLOC_THRESHOLD "10" CACHE STRING
    "Threshold for malloc() usage. See POSIX_MALLOC_THRESHOLD in config.h.in for details.")

SET(PCRE_SUPPORT_JIT OFF CACHE BOOL
    "Enable support for Just-in-time compiling.")

SET(PCRE_SUPPORT_PCREGREP_JIT ON CACHE BOOL
    "Enable use of Just-in-time compiling in pcregrep.")

SET(PCRE_SUPPORT_UTF OFF CACHE BOOL
    "Enable support for Unicode Transformation Format (UTF-8 and/or UTF-16) encoding.")

SET(PCRE_SUPPORT_UNICODE_PROPERTIES OFF CACHE BOOL
    "Enable support for Unicode properties (if set, UTF support will be enabled as well).")

SET(PCRE_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL
    "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")

OPTION(PCRE_SHOW_REPORT    "Show the final configuration report" ON)
OPTION(PCRE_BUILD_PCREGREP "Build pcregrep" ON)
OPTION(PCRE_BUILD_TESTS    "Build the tests" ON)

IF (MINGW)
  OPTION(NON_STANDARD_LIB_PREFIX
         "ON=Shared libraries built in mingw will be named pcre.dll, etc., instead of libpcre.dll, etc."
         OFF)

  OPTION(NON_STANDARD_LIB_SUFFIX
         "ON=Shared libraries built in mingw will be named libpcre-0.dll, etc., instead of libpcre.dll, etc."
         OFF)
ENDIF(MINGW)

# bzip2 lib
IF(BZIP2_FOUND)
  OPTION (PCRE_SUPPORT_LIBBZ2 "Enable support for linking pcregrep with libbz2." ON)
ENDIF(BZIP2_FOUND)
IF(PCRE_SUPPORT_LIBBZ2)
  INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBBZ2)

# zlib
IF(ZLIB_FOUND)
  OPTION (PCRE_SUPPORT_LIBZ "Enable support for linking pcregrep with libz." ON)
ENDIF(ZLIB_FOUND)
IF(PCRE_SUPPORT_LIBZ)
  INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBZ)

# editline lib
IF(EDITLINE_FOUND)
  OPTION (PCRE_SUPPORT_LIBEDIT  "Enable support for linking pcretest with libedit." OFF)
ENDIF(EDITLINE_FOUND)
IF(PCRE_SUPPORT_LIBEDIT)
  INCLUDE_DIRECTORIES(${EDITLINE_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBEDIT)

# readline lib
IF(READLINE_FOUND)
  OPTION (PCRE_SUPPORT_LIBREADLINE  "Enable support for linking pcretest with libreadline." ON)
ENDIF(READLINE_FOUND)
IF(PCRE_SUPPORT_LIBREADLINE)
  INCLUDE_DIRECTORIES(${READLINE_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBREADLINE)

# Prepare build configuration

SET(pcre_have_type_traits 0)
SET(pcre_have_bits_type_traits 0)

IF(HAVE_TYPE_TRAITS_H)
        SET(pcre_have_type_traits 1)
ENDIF(HAVE_TYPE_TRAITS_H)

IF(HAVE_BITS_TYPE_TRAITS_H)
        SET(pcre_have_bits_type_traits 1)
ENDIF(HAVE_BITS_TYPE_TRAITS_H)

SET(pcre_have_long_long 0)
SET(pcre_have_ulong_long 0)

IF(HAVE_LONG_LONG)
        SET(pcre_have_long_long 1)
ENDIF(HAVE_LONG_LONG)

IF(HAVE_UNSIGNED_LONG_LONG)
        SET(pcre_have_ulong_long 1)
ENDIF(HAVE_UNSIGNED_LONG_LONG)

IF(NOT BUILD_SHARED_LIBS)
        SET(PCRE_STATIC 1)
ENDIF(NOT BUILD_SHARED_LIBS)

IF(NOT PCRE_BUILD_PCRE8 AND NOT PCRE_BUILD_PCRE16)
        MESSAGE(FATAL_ERROR "Either PCRE_BUILD_PCRE8 or PCRE_BUILD_PCRE16 must be enabled")
ENDIF(NOT PCRE_BUILD_PCRE8 AND NOT PCRE_BUILD_PCRE16)

IF(PCRE_BUILD_PCRE8)
        SET(SUPPORT_PCRE8 1)
ENDIF(PCRE_BUILD_PCRE8)

IF(PCRE_BUILD_PCRE16)
        SET(SUPPORT_PCRE16 1)
ENDIF(PCRE_BUILD_PCRE16)

IF(PCRE_BUILD_PCRECPP AND NOT PCRE_BUILD_PCRE8)
        MESSAGE(STATUS "** PCRE_BUILD_PCRE8 must be enabled for the C++ library support")
        SET(PCRE_BUILD_PCRECPP OFF)
ENDIF(PCRE_BUILD_PCRECPP AND NOT PCRE_BUILD_PCRE8)

IF(PCRE_BUILD_PCREGREP AND NOT PCRE_BUILD_PCRE8)
        MESSAGE(STATUS "** PCRE_BUILD_PCRE8 must be enabled for the pcregrep program")
        SET(PCRE_BUILD_PCREGREP OFF)
ENDIF(PCRE_BUILD_PCREGREP AND NOT PCRE_BUILD_PCRE8)

IF(PCRE_SUPPORT_LIBREADLINE AND PCRE_SUPPORT_LIBEDIT)
        MESSAGE(FATAL_ERROR "Only one of libreadline or libeditline can be specified")
ENDIF(PCRE_SUPPORT_LIBREADLINE AND PCRE_SUPPORT_LIBEDIT)

IF(PCRE_SUPPORT_BSR_ANYCRLF)
        SET(BSR_ANYCRLF 1)
ENDIF(PCRE_SUPPORT_BSR_ANYCRLF)

IF(PCRE_SUPPORT_UTF OR PCRE_SUPPORT_UNICODE_PROPERTIES)
        SET(SUPPORT_UTF 1)
        SET(PCRE_SUPPORT_UTF ON)
ENDIF(PCRE_SUPPORT_UTF OR PCRE_SUPPORT_UNICODE_PROPERTIES)

IF(PCRE_SUPPORT_UNICODE_PROPERTIES)
        SET(SUPPORT_UCP 1)
ENDIF(PCRE_SUPPORT_UNICODE_PROPERTIES)

IF(PCRE_SUPPORT_JIT)
        SET(SUPPORT_JIT 1)
ENDIF(PCRE_SUPPORT_JIT)

IF(PCRE_SUPPORT_PCREGREP_JIT)
        SET(SUPPORT_PCREGREP_JIT 1)
ENDIF(PCRE_SUPPORT_PCREGREP_JIT)

# This next one used to contain
#       SET(PCRETEST_LIBS ${READLINE_LIBRARY})
# but I was advised to add the NCURSES test as well, along with
# some modifications to cmake/FindReadline.cmake which should
# make it possible to override the default if necessary. PH

IF(PCRE_SUPPORT_LIBREADLINE)
        SET(SUPPORT_LIBREADLINE 1)
        SET(PCRETEST_LIBS ${READLINE_LIBRARY} ${NCURSES_LIBRARY})
ENDIF(PCRE_SUPPORT_LIBREADLINE)

# libedit is a plug-compatible alternative to libreadline

IF(PCRE_SUPPORT_LIBEDIT)
        SET(SUPPORT_LIBEDIT 1)
        SET(PCRETEST_LIBS ${EDITLINE_LIBRARY} ${NCURSES_LIBRARY})
ENDIF(PCRE_SUPPORT_LIBEDIT)

IF(PCRE_SUPPORT_LIBZ)
        SET(SUPPORT_LIBZ 1)
        SET(PCREGREP_LIBS ${PCREGREP_LIBS} ${ZLIB_LIBRARIES})
ENDIF(PCRE_SUPPORT_LIBZ)

IF(PCRE_SUPPORT_LIBBZ2)
        SET(SUPPORT_LIBBZ2 1)
        SET(PCREGREP_LIBS ${PCREGREP_LIBS} ${BZIP2_LIBRARIES})
ENDIF(PCRE_SUPPORT_LIBBZ2)

SET(NEWLINE "")

IF(PCRE_NEWLINE STREQUAL "LF")
        SET(NEWLINE "10")
ENDIF(PCRE_NEWLINE STREQUAL "LF")
IF(PCRE_NEWLINE STREQUAL "CR")
        SET(NEWLINE "13")
ENDIF(PCRE_NEWLINE STREQUAL "CR")
IF(PCRE_NEWLINE STREQUAL "CRLF")
        SET(NEWLINE "3338")
ENDIF(PCRE_NEWLINE STREQUAL "CRLF")
IF(PCRE_NEWLINE STREQUAL "ANY")
        SET(NEWLINE "-1")
ENDIF(PCRE_NEWLINE STREQUAL "ANY")
IF(PCRE_NEWLINE STREQUAL "ANYCRLF")
        SET(NEWLINE "-2")
ENDIF(PCRE_NEWLINE STREQUAL "ANYCRLF")

IF(NEWLINE STREQUAL "")

=== debian/changelog ===
pcre3 (1:8.31-2ubuntu2) trusty; urgency=low

  * Don't patch the soname in the generated configure file, but in
    configure.ac.
  * Add symbols files to catch the practice to only change the soname
    in the generated files.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Dec 2013 14:18:01 +0100

pcre3 (1:8.31-2ubuntu1) trusty; urgency=low

  * Use dh-autoreconf to update config files.
  * Use explicit stamp for the configure target.
  * Honor dpkg-buildflags.
  * Enable parallel builds.
  * Configure with --disable-silent-rules.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Dec 2013 12:58:45 +0100

pcre3 (1:8.31-2) unstable; urgency=low

  * Build -dev package as Multi-arch: same. Thanks Steve Langasek / Ubuntu
    for the patch (Closes: 696217) 

 -- Mark Baker <mark@mnb.org.uk>  Thu, 03 Jan 2013 20:30:05 +0000

pcre3 (1:8.31-1) unstable; urgency=low

  * New upstream release
  * Applied patch from upstream bugzilla #1287 to fix bug where wrong
    value is in re_nsub in some cases (Closes: #686495)

 -- Mark Baker <mark@mnb.org.uk>  Thu, 13 Sep 2012 19:58:45 +0100

=== debian/rules ===
--- 
+++ 
@@ -11,51 +11,58 @@
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-CFLAGS = -Wall -g
+COMMA = ,
+ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
+  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
+endif
+
+CFLAGS := -Wall $(shell dpkg-buildflags --get CFLAGS)
+CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
+LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+
 INSTALL = install
 INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
 INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
 INSTALL_SCRIPT  = $(INSTALL) -p    -o root -g root  -m  755
 INSTALL_DIR     = $(INSTALL) -p -d -o root -g root  -m  755
 
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-CFLAGS += -O0
-else
-CFLAGS += -O2
-endif
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 INSTALL_PROGRAM += -s
 endif
 
 
-config.status: configure
+configure-stamp:
 	dh_testdir
 	# Add here commands to configure the package.
-	CC_FOR_BUILD=cc CFLAGS="$(CFLAGS)" ./configure \
+	dh_autoreconf
+	CC_FOR_BUILD=cc CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	    ./configure \
 		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
 		--prefix=/usr --mandir=\$${prefix}/share/man \
 		--infodir=\$${prefix}/share/info \
 		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
-		--enable-utf8 --enable-unicode-properties
+		--enable-utf8 --enable-unicode-properties \
+		--disable-silent-rules
+	touch configure-stamp
 
 build: build-arch build-indep
 build-arch: build-stamp
 build-indep: build-stamp
-build-stamp:  config.status
+build-stamp:  configure-stamp
 	dh_testdir
 
 	# Add here commands to compile the package.
-	$(MAKE)
+	$(MAKE) $(NJOBS)
 ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
 	$(MAKE) check
 endif
 
 	touch build-stamp
 
-clean: config.status
+clean:
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp
+	rm -f configure-stamp build-stamp
 	# Add here commands to clean up after the build process.
 	[ ! -f Makefile ] || $(MAKE) distclean
 ###	-test -r /usr/share/misc/config.sub && \
@@ -63,6 +70,7 @@
 ###	-test -r /usr/share/misc/config.guess && \
 ###	  cp -f /usr/share/misc/config.guess config.guess
 	rm -f dftables testsavedregex
+	dh_autoreconf_clean
 	dh_clean
 
 install: build
@@ -85,6 +93,9 @@
 	mkdir -p debian/libpcre3/lib/$(DEB_HOST_MULTIARCH)
 	mv debian/libpcre3/usr/lib/$(DEB_HOST_MULTIARCH)/libpcre.so.* debian/libpcre3/lib/$(DEB_HOST_MULTIARCH)
 	ln -sf /lib/$(DEB_HOST_MULTIARCH)/libpcre.so.3 debian/libpcre3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libpcre.so
+	# we never need to reference the library path in pcre-config on
+	# Debian, so clip it out so that the script will be multiarch-safe.
+	sed -i -e"s,/$(DEB_HOST_MULTIARCH),,g" debian/libpcre3-dev/usr/bin/pcre-config
 
 	dh_link -a
 
@@ -108,8 +119,8 @@
 	rm debian/libpcre3-dbg/usr/lib/debug/usr/lib/libpcre*
 	dh_compress -a
 	dh_fixperms -a
-	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb" -V 'libpcre3 (>= 8.10)'
-	dh_makeshlibs -plibpcrecpp0 -V 'libpcrecpp0 (>= 7.7)'
+	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb"
+	dh_makeshlibs -plibpcrecpp0
 	dh_installdeb -a
 #	dh_perl -a
 	dh_shlibdeps -a -ldebian/libpcre3/usr/lib/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=3
ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-(.*)\.zip

## pcre3 8.35

=== debian/changelog ===
pcre3 (2:8.35-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Upstream patch for heap buffer overflow, CVE-2014-8964, taken from
    1:8.36-1 (Closes: #770478)
    Thanks to Salvatore Bonaccorso for the reminder.

 -- Ivo De Decker <ivodd@debian.org>  Sat, 06 Dec 2014 19:58:19 +0100

pcre3 (2:8.35-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Update shlibs dependency to 1:8.35 for new symbol introduced in upstream
    version 8.35 (Closes: #767907)
  * Revert upload of upstream version 8.36 to allow this upload to migrate to
    jessie.

 -- Ivo De Decker <ivodd@debian.org>  Sat, 06 Dec 2014 19:21:39 +0100

pcre3 (1:8.35-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Enable build hardening flags (closes: #656008).

 -- Michael Gilbert <mgilbert@debian.org>  Fri, 19 Sep 2014 01:48:23 +0000

pcre3 (1:8.35-3) unstable; urgency=medium

  Thanks to Simon McVittie for all of the work on this:

  * Run tests with VERBOSE=1 so we can see the logs for failing tests
    (Closes: #755052)
  * Apply part of upstream r1472 to fix undefined behaviour when parsing
    {n} or {m,n} quantifiers, which causes mis-parsing and test failures
    under gcc 4.9 (Closes: #751828)

 -- Mark Baker <mark@mnb.org.uk>  Wed, 23 Jul 2014 21:19:41 +0100

pcre3 (1:8.35-2) unstable; urgency=medium

  * Build-depends on auto-reconf (Closes: 754540)

 -- Mark Baker <mark@mnb.org.uk>  Sat, 12 Jul 2014 23:03:47 +0100

pcre3 (1:8.35-1) unstable; urgency=medium

  * New upstream release
  * Use dh-autoreconf
  * Disable JIT on ppc64el (Closes: 751390) (Thanks Erwan Prioul)

 -- Mark Baker <mark@mnb.org.uk>  Fri, 11 Jul 2014 19:54:51 +0100

pcre3 (1:8.31-5) unstable; urgency=medium

  * Previous attempt at detecting JIT support didn't work when cross
    compiling. Now runs the host compiler, and doesn't try to run the
    output (Closes: 745222)

 -- Mark Baker <mark@mnb.org.uk>  Wed, 23 Apr 2014 21:00:35 +0100

pcre3 (1:8.31-4) unstable; urgency=medium

  * Enable JIT compilation only on architectures where it is supported -
    fixes FTBFS on ones where it isn't (Closes: 745114)
  * Verbose build logs (Closes: 745069)

 -- Mark Baker <mark@mnb.org.uk>  Fri, 18 Apr 2014 10:06:31 +0100

pcre3 (1:8.31-3) unstable; urgency=medium

  * Enable JIT regex compilation (http://sljit.sourceforge.net/pcre).
    Note that this has no effect by default so should not break anything;
    to use it you need to pass a flag to pcre_compile_regex()
    (Closes: 740954)
  * Changed shlibs:Depends to 8.20 as pcre_free_study() is not in older
    versions (Closes: 743164)

 -- Mark Baker <mark@mnb.org.uk>  Tue, 08 Apr 2014 22:37:58 +0100

=== debian/rules ===
--- 
+++ 
@@ -11,15 +11,6 @@
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-COMMA = ,
-ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
-  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
-endif
-
-CFLAGS := -Wall $(shell dpkg-buildflags --get CFLAGS)
-CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
-LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
-
 INSTALL = install
 INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
 INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
@@ -30,19 +21,19 @@
 INSTALL_PROGRAM += -s
 endif
 
-
 configure-stamp:
 	dh_testdir
 	# Add here commands to configure the package.
 	dh_autoreconf
-	CC_FOR_BUILD=cc CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
-	    ./configure \
+	CC_FOR_BUILD=cc ./configure \
 		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
 		--prefix=/usr --mandir=\$${prefix}/share/man \
 		--infodir=\$${prefix}/share/info \
 		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 		--enable-utf8 --enable-unicode-properties \
-		--disable-silent-rules
+		--disable-silent-rules \
+		$(shell . debian/jit-test) \
+		$(shell DEB_CFLAGS_MAINT_APPEND=-Wall DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --export=configure)
 	touch configure-stamp
 
 build: build-arch build-indep
@@ -52,9 +43,9 @@
 	dh_testdir
 
 	# Add here commands to compile the package.
-	$(MAKE) $(NJOBS)
+	$(MAKE)
 ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
-	$(MAKE) check
+	$(MAKE) check VERBOSE=1
 endif
 
 	touch build-stamp
@@ -119,8 +110,8 @@
 	rm debian/libpcre3-dbg/usr/lib/debug/usr/lib/libpcre*
 	dh_compress -a
 	dh_fixperms -a
-	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb"
-	dh_makeshlibs -plibpcrecpp0
+	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb" -V 'libpcre3 (>= 1:8.35)'
+	dh_makeshlibs -plibpcrecpp0 -V 'libpcrecpp0 (>= 7.7)'
 	dh_installdeb -a
 #	dh_perl -a
 	dh_shlibdeps -a -ldebian/libpcre3/usr/lib/$(DEB_HOST_MULTIARCH)

## pcre3 8.36

=== debian/changelog ===
pcre3 (1:8.36-1) unstable; urgency=medium

  * New upstream release
  * Upped shlibs dependency to 8.35 (Closes: #767903)
  * Upstream patch for heap buffer overflow, CVE-2014-8964 (Closes: #770478)

 -- Mark Baker <mark@mnb.org.uk>  Mon, 24 Nov 2014 22:41:12 +0000

pcre3 (1:8.35-3.2) unstable; urgency=low

  * Non-maintainer upload with maintainer permission.
  * Disable JIT on x32 and powerpcspe (Closes: #760327).

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 12 Nov 2014 14:30:23 +0000

=== debian/rules ===
--- 
+++ 
@@ -110,7 +110,7 @@
 	rm debian/libpcre3-dbg/usr/lib/debug/usr/lib/libpcre*
 	dh_compress -a
 	dh_fixperms -a
-	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb" -V 'libpcre3 (>= 1:8.35)'
+	dh_makeshlibs -plibpcre3 --add-udeb="libpcre3-udeb" -V 'libpcre3 (>= 8.35)'
 	dh_makeshlibs -plibpcrecpp0 -V 'libpcrecpp0 (>= 7.7)'
 	dh_installdeb -a
 #	dh_perl -a
